All Downloads are FREE. Search and download functionalities are using the official Maven repository.

g2301_2400.s2312_selling_pieces_of_wood.Solution Maven / Gradle / Ivy

There is a newer version: 1.38
Show newest version
package g2301_2400.s2312_selling_pieces_of_wood;

// #Hard #Backtracking #2022_06_20_Time_78_ms_(63.64%)_Space_53.1_MB_(63.64%)

/**
 * 2312 - Selling Pieces of Wood\.
 *
 * Hard
 *
 * You are given two integers `m` and `n` that represent the height and width of a rectangular piece of wood. You are also given a 2D integer array `prices`, where prices[i] = [hi, wi, pricei] indicates you can sell a rectangular piece of wood of height hi and width wi for pricei dollars.
 *
 * To cut a piece of wood, you must make a vertical or horizontal cut across the **entire** height or width of the piece to split it into two smaller pieces. After cutting a piece of wood into some number of smaller pieces, you can sell pieces according to `prices`. You may sell multiple pieces of the same shape, and you do not have to sell all the shapes. The grain of the wood makes a difference, so you **cannot** rotate a piece to swap its height and width.
 *
 * Return _the **maximum** money you can earn after cutting an_ `m x n` _piece of wood_.
 *
 * Note that you can cut the piece of wood as many times as you want.
 *
 * **Example 1:**
 *
 * ![](https://assets.leetcode.com/uploads/2022/04/27/ex1.png)
 *
 * **Input:** m = 3, n = 5, prices = \[\[1,4,2],[2,2,7],[2,1,3]]
 *
 * **Output:** 19
 *
 * **Explanation:** The diagram above shows a possible scenario. It consists of:
 *
 * - 2 pieces of wood shaped 2 x 2, selling for a price of 2 \* 7 = 14.
 *
 * - 1 piece of wood shaped 2 x 1, selling for a price of 1 \* 3 = 3.
 *
 * - 1 piece of wood shaped 1 x 4, selling for a price of 1 \* 2 = 2.
 *
 * This obtains a total of 14 + 3 + 2 = 19 money earned.
 *
 * It can be shown that 19 is the maximum amount of money that can be earned.
 *
 * **Example 2:**
 *
 * ![](https://assets.leetcode.com/uploads/2022/04/27/ex2new.png)
 *
 * **Input:** m = 4, n = 6, prices = \[\[3,2,10],[1,4,2],[4,1,3]]
 *
 * **Output:** 32
 *
 * **Explanation:** The diagram above shows a possible scenario. It consists of:
 *
 * - 3 pieces of wood shaped 3 x 2, selling for a price of 3 \* 10 = 30.
 *
 * - 1 piece of wood shaped 1 x 4, selling for a price of 1 \* 2 = 2.
 *
 * This obtains a total of 30 + 2 = 32 money earned.
 *
 * It can be shown that 32 is the maximum amount of money that can be earned.
 *
 * Notice that we cannot rotate the 1 x 4 piece of wood to obtain a 4 x 1 piece of wood.
 *
 * **Constraints:**
 *
 * *   `1 <= m, n <= 200`
 * *   1 <= prices.length <= 2 * 104
 * *   `prices[i].length == 3`
 * *   1 <= hi <= m
 * *   1 <= wi <= n
 * *   1 <= pricei <= 106
 * *   All the shapes of wood (hi, wi) are pairwise **distinct**.
**/
public class Solution {
    public long sellingWood(int m, int n, int[][] prices) {
        // dp[i][j] = Maximum profit selling wood of size i*j
        long[][] dp = new long[m][n];
        for (int[] price : prices) {
            dp[price[0] - 1][price[1] - 1] = Math.max(dp[price[0] - 1][price[1] - 1], price[2]);
        }
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                // Cut Vertically
                for (int k = 0; k < j; k++) {
                    dp[i][j] = Math.max(dp[i][j], dp[i][k] + dp[i][j - k - 1]);
                }
                // Cut Horizontally
                for (int k = 0; k < i; k++) {
                    dp[i][j] = Math.max(dp[i][j], dp[k][j] + dp[i - k - 1][j]);
                }
            }
        }
        return dp[m - 1][n - 1];
    }
}




© 2015 - 2025 Weber Informatics LLC | Privacy Policy